#    One Room And A Goblin Invasion
#    Copyright (C) 2014  Jannik Haberbosch
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

import pygame
pygame.init()


def collision_projectiles_goblins(
	projectiles,
	goblins,
	hits ):
	"""Checks for collisions and performs the necessary actions.

	"""

	goblins = filter( lambda x: x.dying == False, goblins )
	sprites = pygame.sprite.groupcollide(
		goblins,
		projectiles,
		False,
		True
	)

	hits += len( sprites )

	collided_projectiles = []
	
	for s in sprites.items():
		s[0].dying = True
		for x in s[1]:
			collided_projectiles.append(
				x
			)

	return collided_projectiles, hits


def collision_player_garbage(
	player,
	garbage ):
	"""

	"""
	if player.current_animation == player.animation_cleaning:
		for x in garbage:
			if x.rect.colliderect( player ):
				x.kill()
