#    One Room And A Goblin Invasion
#    Copyright (C) 2014  Jannik Haberbosch
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.


# First we need a tuple that represents the images to blit when the goblin is
# walking.
ANIMATION_WALKING_IMAGES = (
	"goblin_purple_walking1.png",
	"goblin_purple_walking2.png",
	"goblin_purple_walking3.png",
	"goblin_purple_walking4.png",
	"goblin_purple_walking5.png",
	"goblin_purple_walking6.png",
	"goblin_purple_walking7.png"
)

# The data for the timer controls the behaviour of the animation.
ANIMATION_WALKING_TIMER_INFO = (
	1,
	1
)


# Next we need a tuple that represents the images to blit when the goblin is...
# doing nothing, namely just standing.
ANIMATION_STANDING_IMAGES = (
	"goblin_purple_standing.png",
)

# For this animation, we also need a timer which controls the animation.
ANIMATION_STANDING_TIMER_INFO = (
	5,
	1
)
