#    One Room And A Goblin Invasion
#    Copyright (C) 2014  Jannik Haberbosch
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.


# Python modules
import os
import os.path

# 3rd party modules
import pygame
pygame.init()


# Images for the animation if the player is moving.
ANIMATION_WALKING_IMAGES = (
	"player_1_walking1.png",
	"player_1_walking2.png",
	"player_1_walking3.png",
	"player_1_walking4.png",
	"player_1_walking5.png",
	"player_1_walking6.png",
	"player_1_walking7.png",
	"player_1_walking8.png",
)

# The first value represents at which interval an image from the animation
# should be changed.  A value of 1 means that the image is changed each frame.
ANIMATION_WALKING_TIMER_INFO = (
	1,
	1
)


# Images for the animation if the player is cleaning the floor.
ANIMATION_CLEANING_IMAGES = (
	"player_1_cleaning1.png",
	"player_1_cleaning2.png",
	"player_1_cleaning3.png",
	"player_1_cleaning4.png",
	"player_1_cleaning5.png"
)

# Again we need data for the timer which controls the behaviour of the animation.
ANIMATION_CLEANING_TIMER_INFO = (
	1,
	1
)


# Images for the animation if the player is just standing doing nothing (except
# turning).
ANIMATION_STANDING_IMAGES = (
	"player_1_standing1.png",
)

# And again we need data for the timer which controls the behaviour of the ani-
# mation.
ANIMATION_STANDING_TIMER_INFO = (
	1,
	1
)


# The starting position of our character.  The character will have its' center
# at this location.
# These values can change, thus a list is required instead of a tuple.
POSITION_CENTER = [
	200, # px
	200 # px
]
